#include<fstream>
#include<string>
#include<cmath>
using namespace std;

void atob(int a[],double b[],int num)
{
  int s=0;
  for(int i=0;i<num;i++){
    s+=a[i];
  }
  for(int i=0;i<num;i++){
    if(a[i]!=0)b[i]=10*(log(a[i])-log(s))/log(10);
    else b[i]=-3000;
  }
}

void natob(int a[],double b[],double c[])
{
  int s=0;
  for(int i=0;i<4;i++){
    s+=a[i];
  }
  for(int i=0;i<4;i++){
    if(a[i]!=0)b[i]=10*(log(a[i])-log(s))/log(10)-c[i];
    else b[i]=-3000;
  }
}

void smoothing(int a[],int b[],int num,int size)
{
  int i,j,s;
  for(i=0;i<size/2;i++)b[i]=a[i];
  for(i=size/2;i<num-size/2;i++){
    s=0;
    for(j=i-size/2;j<=i+size/2;j++)s+=a[j];
    b[i]=s/size+1;
  }
  for(i=num-size/2;i<num;i++)b[i]=a[i];
}

int main()
{
  string s,sn;
  int a[1000];
  double c[4];
  ifstream in("para.tmp.txt",ios::in);
  bool flag=false;
  while(in>>s)if(s=="NULL"){
    flag=true;
    break;
  }
  if(flag){
    in>>sn;
    while(in>>s)if(s==sn)break;
    in>>s;
    in>>a[0]>>a[1]>>a[2]>>a[3];
    atob(a,c,4);
  }else{
    c[0]=0;c[1]=0;c[2]=0;c[3]=0;
  }
  int states;
  ifstream infile("para.tmp.txt",ios::in);
  ofstream outfile("para.txt",ios::out);
  infile>>states;
  outfile<<"[STATES]\n"<<states<<endl<<"[NAME]\n";
  for(int i=0;i<states-1;i++){
    infile>>s;
    outfile<<s<<" ";
  }
  infile>>s;
  outfile<<s<<endl<<"[TYPE]\n";
  for(int i=0;i<states-1;i++){
    infile>>s;
    outfile<<s<<" ";
  }
  infile>>s;
  outfile<<s<<endl<<"[START]\n";
  int sa[1000];
  double b[1000];
  for(int i=0;i<states;i++){
    infile>>a[i];
  }
  atob(a,b,states);
  for(int i=0;i<states-1;i++){
    outfile<<b[i]<<" ";
  }
  outfile<<b[states-1]<<endl<<endl<<"[*]\n";
  int trans[states][states+1];
  for(int i=0;i<states;i++){
    for(int j=0;j<=states;j++){
      infile>>trans[i][j];
    }
  }
  if(flag){
    infile>>s;
    infile>>s;
  }
  short type;
  string sname;
  double ave;
  int length;
  for(int i=0;i<states;i++){
    infile>>type;
    infile>>sname;
    outfile<<"["<<sname<<"]\n";
    if(type==1){
      infile>>ave;
      outfile<<"[Emission]\n";
      for(int ii=0;ii<4;ii++)infile>>a[ii];
      natob(a,b,c);
      for(int ii=0;ii<3;ii++)outfile<<b[ii]<<" ";
      outfile<<b[3]<<endl<<"[Transition]\n";
      int sum=0;
      for(int ii=0;ii<=states;ii++)sum+=trans[i][ii];
      trans[i][i]=int(sum*ave);
      atob(trans[i],b,states+1);
      for(int ii=0;ii<states;ii++)outfile<<b[ii]<<" ";
      outfile<<b[states]<<endl<<endl;
    }else if(type==2){
      infile>>length;
      outfile<<"[Max_Length]\n"<<length<<endl<<"[Emission]\n";
      for(int ii=0;ii<4;ii++)infile>>a[ii];
      natob(a,b,c);
      for(int ii=0;ii<3;ii++)outfile<<b[ii]<<" ";
      outfile<<b[3]<<endl<<"[Duration]\n";
      for(int ii=0;ii<length;ii++)infile>>a[ii];
      //      smoothing(a,sa,length,5);
      //      atob(sa,b,length);
      atob(a,b,length);
      for(int ii=0;ii<length-1;ii++)outfile<<b[ii]<<" ";
      outfile<<b[length-1]<<endl<<"[Transition]\n";
      atob(trans[i],b,states+1);
      for(int ii=0;ii<states;ii++)outfile<<b[ii]<<" ";
      outfile<<b[states]<<endl<<endl;
    }else if(type==3){
      infile>>length;
      outfile<<"[Length]\n"<<length<<endl<<"[PSSM]\n";
      for(int ii=0;ii<length;ii++){
	for(int j=0;j<4;j++)infile>>a[j];
	natob(a,b,c);
	for(int j=0;j<3;j++)outfile<<b[j]<<" ";
	outfile<<b[3]<<endl;
      }
      outfile<<"[Transition]\n";
      atob(trans[i],b,states+1);
      for(int ii=0;ii<states;ii++)outfile<<b[ii]<<" ";
      outfile<<b[states]<<endl<<endl;
    }
  }
}
